diff --git a/oflog/include/dcmtk/oflog/config/windowsh.h b/oflog/include/dcmtk/oflog/config/windowsh.h
new file mode 100644
index 0000000..26e5cc6
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/config/windowsh.h
@@ -0,0 +1,159 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    windowsh-inc.h
+// Created: 4/2010
+// Author:  Vaclav Zeman
+//
+//
+//  Copyright (C) 2010-2012, Vaclav Zeman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// NOTE: This file is a fragment intentionally left without include guards.
+
+#if defined (_WIN32)
+#undef WIN32_LEAN_AND_MEAN
+#define WIN32_LEAN_AND_MEAN
+
+#undef NOGDICAPMASKS
+#define NOGDICAPMASKS
+
+#undef NOVIRTUALKEYCODES
+#define NOVIRTUALKEYCODES
+
+#undef NOWINMESSAGES
+#define NOWINMESSAGES
+
+#undef NOWINSTYLES
+#define NOWINSTYLES
+
+#undef NOSYSMETRICS
+#define NOSYSMETRICS
+
+#undef NOMENUS
+#define NOMENUS
+
+#undef NOICONS
+#define NOICONS
+
+#undef NOKEYSTATES
+#define NOKEYSTATES
+
+#undef NOSYSCOMMANDS
+#define NOSYSCOMMANDS
+
+#undef NORASTEROPS
+#define NORASTEROPS
+
+#undef NOSHOWWINDOW
+#define NOSHOWWINDOW
+
+#undef NOATOM
+#define NOATOM
+
+#undef NOCLIPBOARD
+#define NOCLIPBOARD
+
+#undef NOCOLOR
+#define NOCOLOR
+
+#undef NOCTLMGR
+#define NOCTLMGR
+
+#undef NODRAWTEXT
+#define NODRAWTEXT
+
+#undef NOGDI
+#define NOGDI
+
+#undef NOKERNEL
+#define NOKERNEL
+
+#undef NOUSER
+#define NOUSER
+
+#undef NONLS
+#define NONLS
+
+#undef NOMB
+#define NOMB
+
+#undef NOMEMMGR
+#define NOMEMMGR
+
+#undef NOMETAFILE
+#define NOMETAFILE
+
+#undef NOMINMAX
+#define NOMINMAX
+
+#undef NOMSG
+#define NOMSG
+
+#undef NOOPENFILE
+#define NOOPENFILE
+
+#undef NOSCROLL
+#define NOSCROLL
+
+#undef NOSERVICE
+#define NOSERVICE
+
+#undef NOSOUND
+#define NOSOUND
+
+#undef NOTEXTMETRIC
+#define NOTEXTMETRIC
+
+#undef NOWH
+#define NOWH
+
+#undef NOWINOFFSETS
+#define NOWINOFFSETS
+
+#undef NOCOMM
+#define NOCOMM
+
+#undef NOKANJI
+#define NOKANJI
+
+#undef NOHELP
+#define NOHELP
+
+#undef NOPROFILER
+#define NOPROFILER
+
+#undef NODEFERWINDOWPOS
+#define NODEFERWINDOWPOS
+
+#undef NOMCX
+#define NOMCX
+
+#include <winsock2.h>
+#include <ws2tcpip.h>
+#include <windows.h>
+#if defined (DCMTK_LOG4CPLUS_HAVE_INTRIN_H)
+#include <intrin.h>
+#endif
+#endif
+
+// NOTE: This file is a fragment intentionally left without include guards.
diff --git a/oflog/include/dcmtk/oflog/configrt.h b/oflog/include/dcmtk/oflog/configrt.h
index f947f96..e155c8b 100644
--- a/oflog/include/dcmtk/oflog/configrt.h
+++ b/oflog/include/dcmtk/oflog/configrt.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    configurator.h
+// File:    configrt.h
 // Created: 3/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,35 +21,40 @@
 
 /** @file */
 
-#ifndef DCMTK__CONFIGURATOR_HEADER_
-#define DCMTK__CONFIGURATOR_HEADER_
+#ifndef DCMTK_LOG4CPLUS_CONFIGURATOR_HEADER_
+#define DCMTK_LOG4CPLUS_CONFIGURATOR_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
-#include "dcmtk/oflog/hierarchy.h"
 #include "dcmtk/oflog/logger.h"
-#include "dcmtk/oflog/helpers/lloguser.h"
 #include "dcmtk/oflog/helpers/pointer.h"
 #include "dcmtk/oflog/helpers/property.h"
 
-//#include <map>
+#include "dcmtk/ofstd/ofmap.h"
 
 
 namespace dcmtk
 {
 namespace log4cplus
 {
+    class Hierarchy;
+
 
     /**
      * Provides configuration from an external file.  See configure() for
      * the expected format.
-     *
+     * 
      * <em>All option values admit variable substitution.</em> For
      * example, if <code>userhome</code> environment property is set to
      * <code>/home/xyz</code> and the File option is set to the string
      * <code>${userhome}/test.log</code>, then File option will be
      * interpreted as the string <code>/home/xyz/test.log</code>.
-     *
+     * 
      * The syntax of variable substitution is similar to that of UNIX
      * shells. The string between an opening <b>&quot;${&quot;</b> and
      * closing <b>&quot;}&quot;</b> is interpreted as a key. Its value is
@@ -56,22 +62,39 @@ namespace log4cplus
      * the ${variableName} sequence.
      */
     class DCMTK_LOG4CPLUS_EXPORT PropertyConfigurator
-        : protected helpers::LogLogUser
     {
     public:
         enum PCFlags
         {
-            fRecursiveExpansion = 0x0001,
-            fShadowEnvironment  = 0x0002,
-            fAllowEmptyVars     = 0x0004
-        };
+            fRecursiveExpansion   = (1 << 0)
+            , fShadowEnvironment  = (1 << 1)
+            , fAllowEmptyVars     = (1 << 2)
+
+            // These encoding related options occupy 2 bits of the flags
+            // and are mutually exclusive. These flags are synchronized with
+            // PFlags in Properties.
 
+            , fEncodingShift      = 3
+            , fEncodingMask       = 0x3
+            , fUnspecEncoding     = (0 << fEncodingShift)
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF8_FACET) && defined (UNICODE)
+            , fUTF8               = (1 << fEncodingShift)
+#endif
+#if (defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF16_FACET) || defined (_WIN32)) \
+    && defined (UNICODE)
+            , fUTF16              = (2 << fEncodingShift)
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF32_FACET) && defined (UNICODE)
+            , fUTF32              = (3 << fEncodingShift)
+#endif
+        };
+        
         // ctor and dtor
-        PropertyConfigurator(const tstring& propertyFile,
+        PropertyConfigurator(const log4cplus::tstring& propertyFile,
             Hierarchy& h = Logger::getDefaultHierarchy(), unsigned flags = 0);
-        PropertyConfigurator(const helpers::Properties& props,
+        PropertyConfigurator(const log4cplus::helpers::Properties& props,
             Hierarchy& h = Logger::getDefaultHierarchy(), unsigned flags = 0);
-        PropertyConfigurator(tistream& propertyStream,
+        PropertyConfigurator(log4cplus::tistream& propertyStream,
             Hierarchy& h = Logger::getDefaultHierarchy(), unsigned flags = 0);
         virtual ~PropertyConfigurator();
 
@@ -84,7 +107,7 @@ namespace log4cplus
          * config.configure();
          * </code>
          */
-        static void doConfigure(const tstring& configFilename,
+        static void doConfigure(const log4cplus::tstring& configFilename,
             Hierarchy& h = Logger::getDefaultHierarchy(), unsigned flags = 0);
 
         /**
@@ -241,16 +264,16 @@ namespace log4cplus
          * prefix removed and references to other properties and/or
          * environment variables expanded.
          */
-        helpers::Properties const & getProperties () const;
+        log4cplus::helpers::Properties const & getProperties () const;
 
         /**
-         * \return The return value is a reference to tstring
+         * \return The return value is a reference to log4cplus::tstring
          * containing filename of properties source file. It will be
          * string "UNAVAILABLE" if the PropertyConfigurator instance has been
          * constructed using one of the other constructors that do not take
          * filename as parameter.
          */
-        tstring const & getPropertyFilename () const;
+        log4cplus::tstring const & getPropertyFilename () const;
 
     protected:
       // Methods
@@ -258,23 +281,23 @@ namespace log4cplus
         void reconfigure();
         void replaceEnvironVariables();
         void configureLoggers();
-        void configureLogger(Logger logger, const tstring& config);
+        void configureLogger(log4cplus::Logger logger, const log4cplus::tstring& config);
         void configureAppenders();
         void configureAdditivity();
-
-        virtual Logger getLogger(const tstring& name);
-        virtual void addAppender(Logger &logger, SharedAppenderPtr& appender);
+        
+        virtual Logger getLogger(const log4cplus::tstring& name);
+        virtual void addAppender(Logger &logger, log4cplus::SharedAppenderPtr& appender);
 
       // Types
-        typedef OFMap<tstring, SharedAppenderPtr> AppenderMap;
+        typedef OFMap<log4cplus::tstring, log4cplus::SharedAppenderPtr> AppenderMap;
 
       // Data
         Hierarchy& h;
-        tstring propertyFilename;
-        helpers::Properties properties;
+        log4cplus::tstring propertyFilename;
+        log4cplus::helpers::Properties properties; 
         AppenderMap appenders;
         unsigned flags;
-
+        
     private:
       // Disable copy
         PropertyConfigurator(const PropertyConfigurator&);
@@ -288,12 +311,14 @@ namespace log4cplus
      * configuration see PropertyConfigurator. BasicConfigurator
      * automatically attaches ConsoleAppender to
      * <code>rootLogger</code>, with output going to standard output,
-     * using DEBUG LogLevel value.
+     * using DEBUG LogLevel value. The additional parameter
+     * logToStdErr may redirect the output to standard error.
      */
     class DCMTK_LOG4CPLUS_EXPORT BasicConfigurator : public PropertyConfigurator {
     public:
       // ctor and dtor
-        BasicConfigurator(Hierarchy& h = Logger::getDefaultHierarchy());
+        BasicConfigurator(Hierarchy& h = Logger::getDefaultHierarchy(),
+            bool logToStdErr = false);
         virtual ~BasicConfigurator();
 
         /**
@@ -305,24 +330,28 @@ namespace log4cplus
          * config.configure();
          * </pre></code>
          */
-        static void doConfigure(Hierarchy& h = Logger::getDefaultHierarchy());
+        static void doConfigure(Hierarchy& h = Logger::getDefaultHierarchy(),
+            bool logToStdErr = false);
 
+        //! Property name for disable override.
+        static log4cplus::tstring const DISABLE_OVERRIDE_KEY;
+        
     private:
       // Disable copy
         BasicConfigurator(const BasicConfigurator&);
         BasicConfigurator& operator=(BasicConfigurator&);
     };
-
+   
 
 #if !defined(DCMTK_LOG4CPLUS_SINGLE_THREADED)
     // Forward Declarations
     class ConfigurationWatchDogThread;
-
-
+    
+    
     class DCMTK_LOG4CPLUS_EXPORT ConfigureAndWatchThread {
     public:
       // ctor and dtor
-        ConfigureAndWatchThread(const tstring& propertyFile,
+        ConfigureAndWatchThread(const log4cplus::tstring& propertyFile,
                                 unsigned int millis = 60 * 1000);
         virtual ~ConfigureAndWatchThread();
 
@@ -330,7 +359,7 @@ namespace log4cplus
       // Disallow copying of instances of this class
        ConfigureAndWatchThread(const ConfigureAndWatchThread&);
        ConfigureAndWatchThread& operator=(const ConfigureAndWatchThread&);
-
+       
       // Data
        ConfigurationWatchDogThread * watchDogThread;
     };
@@ -339,5 +368,5 @@ namespace log4cplus
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__CONFIGURATOR_HEADER_
+#endif // DCMTK_LOG4CPLUS_CONFIGURATOR_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/consap.h b/oflog/include/dcmtk/oflog/consap.h
index fcfa996..3e8588e 100644
--- a/oflog/include/dcmtk/oflog/consap.h
+++ b/oflog/include/dcmtk/oflog/consap.h
@@ -1,5 +1,6 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    consoleappender.h
+// File:    consap.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
@@ -20,10 +21,15 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_CONSOLE_APPENDER_HEADER_
-#define DCMTK__LOG4CPLUS_CONSOLE_APPENDER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_CONSOLE_APPENDER_HEADER_
+#define DCMTK_LOG4CPLUS_CONSOLE_APPENDER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
 
 namespace dcmtk {
@@ -42,14 +48,15 @@ namespace log4cplus {
      * <dt><tt>ImmediateFlush</tt></dt>
      * <dd>When it is set true, output stream will be flushed after
      * each appended event.</dd>
-     *
+     * 
      * </dl>
+     * \sa Appender
      */
     class DCMTK_LOG4CPLUS_EXPORT ConsoleAppender : public Appender {
     public:
       // Ctors
         ConsoleAppender(bool logToStdErr = false, bool immediateFlush = false);
-        ConsoleAppender(const helpers::Properties properties, tstring& error);
+        ConsoleAppender(const log4cplus::helpers::Properties & properties);
 
       // Dtor
         ~ConsoleAppender();
@@ -57,6 +64,10 @@ namespace log4cplus {
       // Methods
         virtual void close();
 
+        //! This mutex is used by ConsoleAppender and helpers::LogLog
+        //! classes to synchronize output to console.
+        static log4cplus::thread::Mutex const & getOutputMutex();
+
     protected:
         virtual void append(const spi::InternalLoggingEvent& event);
 
@@ -72,5 +83,5 @@ namespace log4cplus {
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_CONSOLE_APPENDER_HEADER_
+#endif // DCMTK_LOG4CPLUS_CONSOLE_APPENDER_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/fileap.h b/oflog/include/dcmtk/oflog/fileap.h
index 944fddf..3ff1532 100644
--- a/oflog/include/dcmtk/oflog/fileap.h
+++ b/oflog/include/dcmtk/oflog/fileap.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    fileappender.h
+// File:    fileap.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,33 +21,37 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_FILE_APPENDER_HEADER_
-#define DCMTK__LOG4CPLUS_FILE_APPENDER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_FILE_APPENDER_HEADER_
+#define DCMTK_LOG4CPLUS_FILE_APPENDER_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/appender.h"
 #include "dcmtk/oflog/fstreams.h"
-#include "dcmtk/oflog/helpers/property.h"
 #include "dcmtk/oflog/helpers/timehelp.h"
+#include "dcmtk/oflog/helpers/lockfile.h"
+#include <fstream>
+#include <locale>
+#include <memory>
 
-#if defined(__DECCXX)
-#   define DCMTK_LOG4CPLUS_OPEN_MODE_TYPE DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE::ios::open_mode
-#else
-#   define DCMTK_LOG4CPLUS_OPEN_MODE_TYPE DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE::ios::openmode
-#endif
 
 namespace dcmtk
 {
-namespace log4cplus {
+namespace log4cplus
+{
 
     /**
-     * Appends log events to a file.
-     *
+     * Appends log events to a file. 
+     * 
      * <h3>Properties</h3>
      * <dl>
      * <dt><tt>File</tt></dt>
      * <dd>This property specifies output file name.</dd>
-     *
+     * 
      * <dt><tt>ImmediateFlush</tt></dt>
      * <dd>When it is set true, output stream will be flushed after
      * each appended event.</dd>
@@ -56,22 +61,57 @@ namespace log4cplus {
      * instead of being truncated at opening.</dd>
      *
      * <dt><tt>ReopenDelay</tt></dt>
-     * <dd>This property sets a delay after which the appender will
-     * try to reopen log file again, after last logging failure. The
-     * default value is 1 second. Setting the delay to 0 makes the
-     * appender not to try reopening the stream.
+     * <dd>This property sets a delay after which the appender will try
+     * to reopen log file again, after last logging failure.
+     * </dd>
+     *
+     * <dt><tt>BufferSize</tt></dt>
+     * <dd>Non-zero value of this property sets up buffering of output
+     * stream using a buffer of given size.
+     * </dd>
+     *
+     * <dt><tt>UseLockFile</tt></dt>
+     * <dd>Set this property to <tt>true</tt> if you want your output
+     * to go into a log file shared by multiple processes. When this
+     * property is set to true then log4cplus uses OS specific
+     * facilities (e.g., <code>lockf()</code>) to provide
+     * inter-process file locking.
+     * \sa Appender
+     * </dd>
+     *
+     * <dt><tt>LockFile</tt></dt>
+     * <dd>This property specifies lock file, file used for
+     * inter-process synchronization of log file access. When this
+     * property is not specified, the value is derived from
+     * <tt>File</tt> property by addition of ".lock" suffix. The
+     * property is only used when <tt>UseLockFile</tt> is set to true.
+     * \sa Appender
+     * </dd>
+     *
+     * <dt><tt>Locale</tt></dt>
+     * <dd>This property specifies a locale name that will be imbued
+     * into output stream. Locale can be specified either by system
+     * specific locale name, e.g., <tt>en_US.UTF-8</tt>, or by one of
+     * four recognized keywords: <tt>GLOBAL</tt>, <tt>DEFAULT</tt>
+     * (which is an alias for <tt>GLOBAL</tt>), <tt>USER</tt> and
+     * <tt>CLASSIC</tt>. When specified locale is not available,
+     * <tt>GLOBAL</tt> is used instead. It is possible to register
+     * additional locale keywords by registering an instance of
+     * <code>spi::LocaleFactory</code> in
+     * <code>spi::LocaleFactoryRegistry</code>.
+     * \sa spi::getLocaleFactoryRegistry()
      * </dd>
+     *
      * </dl>
      */
     class DCMTK_LOG4CPLUS_EXPORT FileAppender : public Appender {
     public:
       // Ctors
-        FileAppender(const tstring& filename,
-                     DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode = DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE::ios::trunc,
+        FileAppender(const log4cplus::tstring& filename, 
+                     STD_NAMESPACE ios_base::openmode mode = STD_NAMESPACE ios_base::trunc,
                      bool immediateFlush = true);
-        FileAppender(const helpers::Properties& properties,
-                     tstring& error,
-                     DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode = DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE::ios::trunc);
+        FileAppender(const log4cplus::helpers::Properties& properties,
+                     STD_NAMESPACE ios_base::openmode mode = STD_NAMESPACE ios_base::trunc);
 
       // Dtor
         virtual ~FileAppender();
@@ -79,10 +119,17 @@ namespace log4cplus {
       // Methods
         virtual void close();
 
+      //! Redefine default locale for output stream. It may be a good idea to
+      //! provide UTF-8 locale in case UNICODE macro is defined.
+        virtual STD_NAMESPACE locale imbue(STD_NAMESPACE locale const& loc);
+
+      //! \returns Locale imbued in fstream. 
+        virtual STD_NAMESPACE locale getloc () const;
+
     protected:
         virtual void append(const spi::InternalLoggingEvent& event);
 
-        void open(DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode);
+        void open(STD_NAMESPACE ios_base::openmode mode);
         bool reopen();
 
       // Data
@@ -94,29 +141,34 @@ namespace log4cplus {
          * <code>false</code>, then there is a good chance that the last few
          * logs events are not actually written to persistent media if and
          * when the application crashes.
-         *
+         *  
          * The <code>immediateFlush</code> variable is set to
          * <code>true</code> by default.
          */
         bool immediateFlush;
 
         /**
-         * When any append operation fails, <code>reopenDelay</code> says
-         * for how many seconds the next attempt to re-open the log file and
-         * resume logging will be delayed. If <code>reopenDelay</code> is zero,
-         * each failed append operation will cause log file to be re-opened.
+         * When any append operation fails, <code>reopenDelay</code> says 
+         * for how many seconds the next attempt to re-open the log file and 
+         * resume logging will be delayed. If <code>reopenDelay</code> is zero, 
+         * each failed append operation will cause log file to be re-opened. 
          * By default, <code>reopenDelay</code> is 1 second.
          */
         int reopenDelay;
 
-        tofstream out;
-        tstring filename;
+        unsigned long bufferSize;
+        log4cplus::tchar * buffer;
 
-        helpers::Time reopen_time;
+        log4cplus::tofstream out;
+        log4cplus::tstring filename;
+        log4cplus::tstring localeName;
+
+        log4cplus::helpers::Time reopen_time;
 
     private:
-        void init(const tstring& filename,
-                  DCMTK_LOG4CPLUS_OPEN_MODE_TYPE mode);
+        DCMTK_LOG4CPLUS_PRIVATE void init(const log4cplus::tstring& filename,
+            STD_NAMESPACE ios_base::openmode mode,
+            const log4cplus::tstring& lockFileName);
 
       // Disallow copying of instances of this class
         FileAppender(const FileAppender&);
@@ -148,25 +200,25 @@ namespace log4cplus {
     class DCMTK_LOG4CPLUS_EXPORT RollingFileAppender : public FileAppender {
     public:
       // Ctors
-        RollingFileAppender(const tstring& filename,
+        RollingFileAppender(const log4cplus::tstring& filename,
                             long maxFileSize = 10*1024*1024, // 10 MB
                             int maxBackupIndex = 1,
                             bool immediateFlush = true);
-        RollingFileAppender(const helpers::Properties& properties, tstring& error);
+        RollingFileAppender(const log4cplus::helpers::Properties& properties);
 
       // Dtor
         virtual ~RollingFileAppender();
 
     protected:
         virtual void append(const spi::InternalLoggingEvent& event);
-        void rollover();
+        void rollover(bool alreadyLocked = false);
 
       // Data
         long maxFileSize;
         int maxBackupIndex;
 
     private:
-        void init(long maxFileSize, int maxBackupIndex);
+        DCMTK_LOG4CPLUS_PRIVATE void init(long maxFileSize, int maxBackupIndex);
     };
 
 
@@ -198,36 +250,36 @@ namespace log4cplus {
     class DCMTK_LOG4CPLUS_EXPORT DailyRollingFileAppender : public FileAppender {
     public:
       // Ctors
-        DailyRollingFileAppender(const tstring& filename,
+        DailyRollingFileAppender(const log4cplus::tstring& filename,
                                  DailyRollingFileSchedule schedule = DAILY,
                                  bool immediateFlush = true,
                                  int maxBackupIndex = 10);
-        DailyRollingFileAppender(const helpers::Properties& properties, tstring& error);
+        DailyRollingFileAppender(const log4cplus::helpers::Properties& properties);
 
       // Dtor
         virtual ~DailyRollingFileAppender();
-
+        
       // Methods
         virtual void close();
 
     protected:
         virtual void append(const spi::InternalLoggingEvent& event);
-        void rollover();
-        helpers::Time calculateNextRolloverTime(const helpers::Time& t) const;
-        tstring getFilename(const helpers::Time& t) const;
+        void rollover(bool alreadyLocked = false);
+        log4cplus::helpers::Time calculateNextRolloverTime(const log4cplus::helpers::Time& t) const;
+        log4cplus::tstring getFilename(const log4cplus::helpers::Time& t) const;
 
       // Data
         DailyRollingFileSchedule schedule;
-        tstring scheduledFilename;
-        helpers::Time nextRolloverTime;
+        log4cplus::tstring scheduledFilename;
+        log4cplus::helpers::Time nextRolloverTime;
         int maxBackupIndex;
 
     private:
-        void init(DailyRollingFileSchedule schedule);
+        DCMTK_LOG4CPLUS_PRIVATE void init(DailyRollingFileSchedule schedule);
     };
 
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_FILE_APPENDER_HEADER_
+#endif // DCMTK_LOG4CPLUS_FILE_APPENDER_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/fstreams.h b/oflog/include/dcmtk/oflog/fstreams.h
index bac2da2..7b30bc1 100644
--- a/oflog/include/dcmtk/oflog/fstreams.h
+++ b/oflog/include/dcmtk/oflog/fstreams.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    fstreams.h
 // Created: 4/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2011 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -25,21 +26,34 @@
 
 #include "dcmtk/oflog/config.h"
 
-//#include <fstream>
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tchar.h"
+#include <iosfwd>
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
 
-#if defined(__DECCXX) && !defined(__USE_STD_IOSTREAM)
-#  define DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE
+
+typedef STD_NAMESPACE basic_ofstream<tchar> tofstream;
+typedef STD_NAMESPACE basic_ifstream<tchar> tifstream;
+
+//! \def DCMTK_LOG4CPLUS_FSTREAM_PREFERED_FILE_NAME(X)
+//! \brief Expands into expression that picks the right type for
+//! STD_NAMESPACE fstream file name parameter.
+#if defined (DCMTK_LOG4CPLUS_FSTREAM_ACCEPTS_WCHAR_T) && defined (UNICODE)
+#  define DCMTK_LOG4CPLUS_FSTREAM_PREFERED_FILE_NAME(X) (X)
 #else
-#  define DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE std
+#  define DCMTK_LOG4CPLUS_FSTREAM_PREFERED_FILE_NAME(X) (DCMTK_LOG4CPLUS_TSTRING_TO_STRING(X))
 #endif
 
 
-namespace dcmtk {
-namespace log4cplus {
-    typedef DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE::ofstream tofstream;
-    typedef DCMTK_LOG4CPLUS_FSTREAM_NAMESPACE::ifstream tifstream;
-}
 }
+} // end namespace dcmtk
 
 #endif // DCMTK_LOG4CPLUS_FSTREAMS_HEADER_
-
diff --git a/oflog/include/dcmtk/oflog/helpers/apndimpl.h b/oflog/include/dcmtk/oflog/helpers/apndimpl.h
index d3cdd6a..0731a71 100644
--- a/oflog/include/dcmtk/oflog/helpers/apndimpl.h
+++ b/oflog/include/dcmtk/oflog/helpers/apndimpl.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    appenderattachableimpl.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,35 +21,37 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HELPERS_APPENDER_ATTACHABLE_IMPL_HEADER_
-#define DCMTK__LOG4CPLUS_HELPERS_APPENDER_ATTACHABLE_IMPL_HEADER_
+#ifndef DCMTK_LOG4CPLUS_HELPERS_APPENDER_ATTACHABLE_IMPL_HEADER_
+#define DCMTK_LOG4CPLUS_HELPERS_APPENDER_ATTACHABLE_IMPL_HEADER_
 
 #include "dcmtk/oflog/config.h"
-#include "dcmtk/oflog/layout.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/lloguser.h"
 #include "dcmtk/oflog/helpers/pointer.h"
-#include "dcmtk/oflog/helpers/threads.h"
 #include "dcmtk/oflog/spi/apndatch.h"
+#include "dcmtk/oflog/thread/syncprim.h"
 
-//#include <memory>
-//#include <vector>
+#include <memory>
+#include "dcmtk/ofstd/ofvector.h"
 
 
 namespace dcmtk {
 namespace log4cplus {
     namespace helpers {
-
+ 
         /**
          * This Interface is for attaching Appenders to objects.
          */
-        class DCMTK_LOG4CPLUS_EXPORT AppenderAttachableImpl
-                                   : public spi::AppenderAttachable,
-                                     protected helpers::LogLogUser
+        class DCMTK_LOG4CPLUS_EXPORT AppenderAttachableImpl 
+            : public log4cplus::spi::AppenderAttachable
         {
         public:
           // Data
-            DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE appender_list_mutex;
+            thread::Mutex appender_list_mutex;
 
           // Ctors
             AppenderAttachableImpl();
@@ -72,9 +75,9 @@ namespace log4cplus {
              * Look for an attached appender named as <code>name</code>.
              *
              * Return the appender with that name if in the list. Return null
-             * otherwise.
+             * otherwise.  
              */
-            virtual SharedAppenderPtr getAppender(const tstring& name);
+            virtual SharedAppenderPtr getAppender(const log4cplus::tstring& name);
 
             /**
              * Remove all previously added appenders.
@@ -88,29 +91,31 @@ namespace log4cplus {
 
             /**
              * Remove the appender with the name passed as parameter from the
-             * list of appenders.
+             * list of appenders.  
              */
-            virtual void removeAppender(const tstring& name);
+            virtual void removeAppender(const log4cplus::tstring& name);
 
             /**
-             * Call the <code>doAppend</code> method on all attached appenders.
+             * Call the <code>doAppend</code> method on all attached appenders.  
              */
             int appendLoopOnAppenders(const spi::InternalLoggingEvent& event) const;
 
         protected:
           // Types
-            typedef OFList<SharedAppenderPtr> ListType;
-            typedef OFListIterator(SharedAppenderPtr) ListIteratorType;
-            typedef OFListConstIterator(SharedAppenderPtr) ListConstIteratorType;
+            typedef OFVector<SharedAppenderPtr> ListType;
 
           // Data
             /** Array of appenders. */
             ListType appenderList;
+
+        private:
+            AppenderAttachableImpl(AppenderAttachableImpl const &);
+            AppenderAttachableImpl & operator = (AppenderAttachableImpl const &);
         };  // end class AppenderAttachableImpl
 
     } // end namespace helpers
 } // end namespace log4cplus
-} // namespace dcmtk
+} // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_HELPERS_APPENDER_ATTACHABLE_IMPL_HEADER_
+#endif // DCMTK_LOG4CPLUS_HELPERS_APPENDER_ATTACHABLE_IMPL_HEADER_
 
